**    ModelEco : MODELisation en programmation mathmatique pour l'analyse ECOnomique de l'agriculure    **

*-----------------------------------------------------------------------------*
$Ontext
Nom              Techniques1.gms
Sequence         2 - Le modle d'exploitation agricole
Type             LP
Langage GAMS     Donnes et variables  deux indices (deux dimensions)
Description
"Soit une exploitation agricole qui peut pratiquer trois cultures, le bl, le mas et la tomate,
et deux itinraires techniques, extensif et intensif.
On cherche  dterminer la superficie  cultiver dans chaque culture et la technique  utiliser, sachant que :
Lobjectif de lagriculteur est la maximisation du revenu.

Les besoins en travail sont de :
                 Besoin en travail (h/ha)
Technique        extensif        Intensif
Bl              15              25
Mais             45              50
Tomate           80              100

Les rendements et les couts sont :
                 Rendement (tonne/ha)         Cout (/ha)
Technique        extensif        intensif        extensif        Intensif
Bl              4.5             5.0             250             300
Mais             8.0             10.0            400             500
Tomate           13.0            16.0            1200            1350

Le prix de vente est de 150/tonne pour le bl, 150/tonne pour le mas et 185/tonne pour la tomate.
La surface de lexploitation est de 50 ha, lagriculteur dispose de 2000 heures de travail par an."


$Offtext


*----------                          INDICES                        ----------*
sets
C cultures  /ble,mais, tomate/
T techniques /ext, int/
;

*----------                          DONNEES                        ----------*
scalar
DTERRE disponibilite de terre en hectares        /50/
DMO    disponibilite de travail en heures        /2000/
;

table
BMO(C, T) besoins en travail par hectare et par culture (heures)
        ext   int
ble     15    25
mais    45    50
tomate  80   100
;

table
RDT (C, T) rendement par culture en tonne par hectar
        ext     int
ble     4.5     5.0
mais    8.0    10.0
tomate 13.0    16.0
;

parameter
PX (C) prix de vente par culture en euros
/ ble    150
  mais   150
  tomate 185/
;

table
COUT (C, T) cout variable par culture en euros par ha
        ext    int
ble     250    300
mais    400    500
tomate 1200   1350
;

parameter
MB(C, T) marge brute par culture en euros    ;
MB(C, T) = RDT(C, T)*PX(C)-COUT(C, T);

*----------                         MODELE                          ----------*
variables
   Z    revenu total de l exploitation (euros)
;

positive variables
   X     superficie par culture (hectares)
;

equations
   OBJECTIF       fonction objectif
   TERRE          contrainte de terre
   TRAVAIL        contrainte de travail
;

OBJECTIF..  sum ((C,T), MB(C, T)* X(C, T)) =E= Z ;

TERRE..    sum((C,T), X(C, T)) =l= dterre ;

TRAVAIL..  sum((C,T), BMO(C, T)*X(C, T)) =L= dmo;

model modelS2 premier exemple /all/;

*----------                        SOLUTION                         ----------*
solve modelS2 using LP maximizing Z;

